<?php
require('sms_config.php');
require('sms_inc.php');

// Вход администратора
checkAdmin();

$mode = isset($_GET['mode']) ? $_GET['mode'] : 'num_list';

switch ( $mode ){
	// Просмотр лога продаж
	case 'log':
		$log = readSellLog();
		$template = 'log';
		break;
	
	// Просмотр списка коротких номеров
	case 'num_list':
		$nums = getPhoneNumList();
		$template = 'num_list';
		break;
	
	// Просмотр списка ICQ# для короткого номера
	case 'num':
		if ( !isset($_GET['num']) ){
			die('Не указан короткий номер для просмотра');
		}
		
		$num = $_GET['num'];
		$error = '';
		
		// Перемещение номеров
		if ( isset($_GET['move']) && isset($_GET['i']) ){
			switch ( $_GET['move'] ){
				case 'up':
					moveNumUp($num, $_GET['i']);
					break;
					
				case 'down':
					moveNumDown($num, $_GET['i']);
					break;
			}
			
			header('Location: ?mode='.$mode.'&num='.$num);
			exit;
		}
		
		// Удаление номеров
		if ( $_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['delete']) && isset($_POST['delicq']) && is_array($_POST['delicq']) ){
			foreach ( $_POST['delicq'] as $delete_icq=>$okay ){
				if ( !deleteIcqNumForPhone($delete_icq, $num) ){
					die('Не удалось удалить ICQ#. Текст ошибки: '.$Glob['error']);
				}
			}
		}
		
		// Обновление номеров
		if ( $_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['save']) && isset($_POST['icq']) && isset($_POST['password']) ){
			foreach ( $_POST['icq'] as $old_num=>$new_num ){
				$old_num = trim($old_num);
				$new_num = trim($new_num);
				
				// Если поменян ICQ#, то удаляем старый 
				if ( $old_num!=$new_num ){
					// Удаляем старый номер
					if ( !deleteIcqNumForPhone($old_num, $num) ){
						$error .= '<p>'.$Glob['error'].'</p>';
					}

					// Добавляем ICQ#
					if ( !addIcqNumForPhone($num, $new_num, $_POST['password'][$old_num]) ){
						$error .= '<p>'.$Glob['error'].'</p>';
					}
				}
				else{
					// Обновляем ICQ#
					if ( !updateIcqNumForPhone($num, $new_num, $_POST['password'][$old_num]) ){
						$error .= '<p>'.$Glob['error'].'</p>';
					}
				}
				
			}
		}
		
		// Добавление номеров
		if ( $_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['add']) && isset($_POST['icq']) && isset($_POST['password']) ){
			$add_size = sizeof($_POST['icq']);
			
			for ( $i=0;$i<$add_size;++$i ){
				if ( ($_POST['icq'][$i] || $_POST['password'][$i]) && !addIcqNumForPhone($num, $_POST['icq'][$i], $_POST['password'][$i]) ){
					$error .= '<p>'.$Glob['error'].'</p>';
				}
			}
		}
		
		$icq_nums = getIcqNumsForPhone($num);
		$template = 'icq_list';
		
		break;
		

	// Просмотр пароля
	case 'icq':
		if ( !isset($_GET['num']) ){
			die('Не указан короткий номер для просмотра');
		}
		if ( !isset($_GET['icq']) ){
			die('Не указан ICQ# для просмотра');
		}
		
		$num = $_GET['num'];
		$icq = $_GET['icq'];
		
		$password = getPasswordForPhoneAndIcqNum($num, $icq);
		$template = 'icq_password';
		
		break;

		
	default:
		exit;
}

require(TEMPLATE_DIR.'header.php');
require(TEMPLATE_DIR.$template.'.php');