<?php

/**
 *   
 */
function checkAdmin(){
	if ( isset($_SERVER['PHP_AUTH_USER']) ){
		if ( $_SERVER['PHP_AUTH_USER']==ADMIN_LOGIN && $_SERVER['PHP_AUTH_PW']==ADMIN_PASS ){
			return;
		}
	}
	
	header('WWW-Authenticate: Basic realm="Enter"');
	header('HTTP/1.0 401 Unauthorized');
	echo '<h1>401 Unauthorized</h1>';
	exit;
}

/**
 *     
 *
 * @return array of string
 */
function getPhoneNumList(){
	//     
	$fp = @opendir(PASSWORDS_DIR) or dieMessage('     .   ');
	
	$nums = array();
	
	while ( $dir=readdir($fp) ){
		//      ,
		//    
		if ( is_dir(PASSWORDS_DIR.$dir) && preg_match('/^[0-9]+$/', $dir) ){
			$nums[] = $dir;
		}
	}
	closedir($fp);
	
	return $nums;
}

/**
 *   ICQ#  
 *
 * @param int $phone
 * @return array of (icq=>password, ...)
 */
function getIcqNumsForPhone($phone){
	//  ,  SMS
	$phone = intval($phone);
	
	//  ICQ  
	$nums = array();
	
	//      ICQ 
	$dir = PASSWORDS_DIR.$phone.'/';
	
	//    
	if ( !file_exists($dir) ){
		dieMessage('   ICQ  ');
	}
	
	//     
	$sort = file($dir.'sort.txt');
	
	foreach ( $sort as $icq_num ){
		$icq_num = trim($icq_num);
		//   
		if ( file_exists($dir.$icq_num.'.txt') ){
			$nums[$icq_num] = getPasswordForPhoneAndIcqNum($phone, $icq_num);
		}
	}
	
	return $nums;
}

/**
 *   ICQ#  
 *
 * @param int $phone
 * @return array of icq#
 */
function getIcqNumsForPhoneWithoutPasswords($phone){
	//  ,  SMS
	$phone = intval($phone);
	
	//  ICQ  
	$nums = array();
	
	//      ICQ 
	$dir = PASSWORDS_DIR.$phone.'/';
	
	//    
	if ( !file_exists($dir) ){
		dieMessage('   ICQ  ');
	}
	
	//     
	$sort = file($dir.'sort.txt');
	
	foreach ( $sort as $icq_num ){
		$nums[] = trim($icq_num);
	}
	
	return $nums;
}

/**
 *    ICQ#
 *
 * @param int $phone
 * @param int $num
 * @return string
 */
function getPasswordForPhoneAndIcqNum($phone, $num){
	$phone	= intval($phone);
	$num	= intval($num);
	
	//      
	$file = PASSWORDS_DIR.$phone.'/'.$num.'.txt';
	
	if ( !file_exists($file) || !is_file($file) ){
		dieMessage('      ICQ# '.$num);
	}
	
	$fp = @fopen($file, 'r') or dieMessage('       ICQ# '.$num);
	
	$password = '';
	
	while ( !feof($fp) ){
		$password .= fread($fp, 128);
	}
	
	fclose($fp);
	
	return $password;
}

/**
 *   
 * 
 *      
 *     
 *  $Glob['error'] 
 *
 * @param int $icq
 * @param int $phone
 * @return boolean
 */
function deleteIcqNumForPhone($icq, $phone){
	global $Glob;
	
	$icq	= intval($icq);
	$phone	= intval($phone);
	
	//      
	$file = PASSWORDS_DIR.$phone.'/'.$icq.'.txt';
	
	if ( !file_exists($file) || !is_file($file) ){
		$Glob['error'] = '      ICQ# '.$icq.' ('.$phone.')';
		return false;
	}
	
	if ( !@unlink($file) ){
		//      
		$Glob['error'] = '   ';
		return false;
	}
	
	fixSortFile($phone);
	
	return true;
}

/**
 *  ICQ#
 * 
 *      
 *     
 * $Glob['error']
 *
 * @param int $phone
 * @param int $icq
 * @param string $password
 * @return boolean
 */
function addIcqNumForPhone($phone, $icq, $password){
	global $Glob;
	
	if ( !preg_match('/^([0-9]+)$/', $icq) ){
		$Glob['error'] = '<b>ICQ#'.$icq.':</b> ICQ#    ';
		return false;
	}
	
	$phone		= intval($phone);
	$icq		= intval($icq);
	$password	= trim($password);
	
	if ( !$icq ){
		$Glob['error'] = 'ICQ#  ';
		return false;
	}
	
	if ( !$password ){
		$Glob['error'] = '<b>ICQ#'.$icq.':</b>   ';
		return false;
	}
	
	//      
	$num_path = PASSWORDS_DIR.$phone.'/';
	
	//   
	$icq_file = $num_path.$icq.'.txt';
	
	if ( !file_exists($num_path) ){
		$Glob['error'] = '<b>ICQ#'.$icq.':</b>      ';
		return false;
	}
	
	if ( file_exists($icq_file) ){
		$Glob['error'] = '<b>ICQ#'.$icq.':</b>  ICQ#  ';
		return false;
	}
	
	$fp = @fopen($icq_file, 'w');
	
	if ( !$fp ){
		$Glob['error'] = '<b>ICQ#'.$icq.':</b>      ';
		return false;
	}
	
	if ( fwrite($fp, $password)===false ){
		fclose($fp);
		unlink($icq_file);
		
		$Glob['error'] = '<b>ICQ#'.$icq.':</b>       ';
		return false;
	}
	
	fclose($fp);
	
	fixSortFile($phone);
	return true;
}

/**
 *  ICQ#
 * 
 *      
 *     
 * $Glob['error']
 *
 * @param int $phone
 * @param int $icq
 * @param string $password
 * @return boolean
 */
function updateIcqNumForPhone($phone, $icq, $password){
	global $Glob;
	
	if ( !preg_match('/^([0-9]+)$/', $icq) ){
		$Glob['error'] = '<b>ICQ#'.$icq.':</b> ICQ#    ';
		return false;
	}
	
	$phone		= intval($phone);
	$icq		= intval($icq);
	$password	= trim($password);
	
	if ( !$icq ){
		$Glob['error'] = 'ICQ#  ';
		return false;
	}
	
	if ( !$password ){
		$Glob['error'] = '<b>ICQ#'.$icq.':</b>   ';
		return false;
	}
	
	//      
	$num_path = PASSWORDS_DIR.$phone.'/';
	
	//   
	$icq_file = $num_path.$icq.'.txt';
	
	if ( !file_exists($num_path) ){
		$Glob['error'] = '<b>ICQ#'.$icq.':</b>      ';
		return false;
	}
	
	if ( !file_exists($icq_file) ){
		$Glob['error'] = '<b>ICQ#'.$icq.':</b>  ICQ#  ';
		return false;
	}
	
	$fp = @fopen($icq_file, 'w');
	
	if ( !$fp ){
		$Glob['error'] = '<b>ICQ#'.$icq.':</b>      ';
		return false;
	}
	
	if ( fwrite($fp, $password)===false ){
		fclose($fp);
		unlink($icq_file);
		
		$Glob['error'] = '<b>ICQ#'.$icq.':</b>       ';
		return false;
	}
	
	fclose($fp);
	return true;
}

/**
 *   
 * 
 *  ,    
 *    
 *
 * @param string $phone
 */
function fixSortFile($phone){
	//  ,  SMS
	$phone = intval($phone);
	
	//  ICQ  
	$nums = array();
	
	//      ICQ 
	$dir = PASSWORDS_DIR.$phone.'/';
	
	//    
	if ( !file_exists($dir) ){
		dieMessage('   ICQ  ');
	}
	
	//     
	$sort = file($dir.'sort.txt');
	
	foreach ( $sort as $icq_num ){
		$icq_num = trim($icq_num);
		//   
		if ( file_exists($dir.$icq_num.'.txt') ){
			$nums[] = $icq_num;
		}
	}
	
	//   
	$fp = @opendir($dir) or dieMessage('      ICQ');
	while ( $icq=readdir($fp) ){
		//    txt   ,
		//   
		if ( preg_match('/^([0-9]+)+(\.txt)$/', $icq) ){
			$icq_num = substr(trim($icq), 0, -4);
			
			if ( array_search($icq_num, $nums)===false ){
				$nums[] = $icq_num;
			}
		}
	}
	closedir($fp);

	if ( !is_writable($dir.'sort.txt') ){
		dieMessage('     ('.$dir.'sort.txt'.')');
	}
	
	//  
	$fp = fopen($dir.'sort.txt', 'w');
	fwrite($fp, implode("\n", $nums));
	fclose($fp);
}

/**
 *   
 *
 * @param string $phone
 * @param int $line
 */
function moveNumUp($phone, $line){
	//  ,  SMS
	$phone = intval($phone);
	
	//   
	$line = intval($line);
	
	//    
	if ( !$line ) return;
	
	//  ICQ  
	$nums = array();
	
	//      ICQ 
	$dir = PASSWORDS_DIR.$phone.'/';
	
	//    
	if ( !file_exists($dir) ){
		dieMessage('   ICQ  ');
	}
	
	//     
	$sort = file($dir.'sort.txt');
	
	foreach ( $sort as $icq_num ){
		$icq_num = trim($icq_num);
		//   
		if ( file_exists($dir.$icq_num.'.txt') ){
			$nums[] = $icq_num;
		}
	}
	
	//    
	if ( sizeof($nums)<=$line ) return;
	
	//      
	$temp = $nums[$line-1];
	$nums[$line-1]	= $nums[$line];
	$nums[$line]	= $temp;

	if ( !is_writable($dir.'sort.txt') ){
		dieMessage('     ('.$dir.'sort.txt'.')');
	}
	
	//  
	$fp = fopen($dir.'sort.txt', 'w');
	fwrite($fp, implode("\n", $nums));
	fclose($fp);
}

/**
 *   
 *
 * @param string $phone
 * @param int $line
 */
function moveNumDown($phone, $line){
	//  ,  SMS
	$phone = intval($phone);
	
	//   
	$line = intval($line);
	
	//  ICQ  
	$nums = array();
	
	//      ICQ 
	$dir = PASSWORDS_DIR.$phone.'/';
	
	//    
	if ( !file_exists($dir) ){
		dieMessage('   ICQ  ');
	}
	
	//     
	$sort = file($dir.'sort.txt');
	
	foreach ( $sort as $icq_num ){
		$icq_num = trim($icq_num);
		//   
		if ( file_exists($dir.$icq_num.'.txt') ){
			$nums[] = $icq_num;
		}
	}
	
	if ( $line>=sizeof($nums)-1 ) return;
	
	//      
	$temp = $nums[$line+1];
	$nums[$line+1]	= $nums[$line];
	$nums[$line]	= $temp;

	if ( !is_writable($dir.'sort.txt') ){
		dieMessage('     ('.$dir.'sort.txt'.')');
	}
	
	//  
	$fp = fopen($dir.'sort.txt', 'w');
	fwrite($fp, implode("\n", $nums));
	fclose($fp);
}

/**
 *    
 *
 * @param int $phone
 * @param int $icq
 * @param int $partner_id
 */
function addSellLog($phone, $icq, $partner_id=0){
	$phone		= intval($phone);
	$icq		= intval($icq);
	$partner_id	= intval($partner_id);
	
	$filename = LOGS_DIR.time().'-'.$phone.'-'.$icq.'-'.$partner_id.'.txt';
	
	$fp = @fopen($filename, 'w');
	if ( !$fp ){
		dieMessage('    ');
	}
	fclose($fp);
}

/**
 *   
 *
 * @return array(
 * 		...,
 * 		array(	
 * 			unix timestamp 	'time',
 * 			int 			'phone',
 * 			string 			'icq',
 * 			int				'partner_id'
 * 		),
 * 		...
 * )
 */
function readSellLog(){
	$folder = opendir(LOGS_DIR) or dieMessage('   ');
	
	$files = array();
	$log = array();
	
	while ( $f=readdir($folder) ){
		if ( is_file(LOGS_DIR.$f) ){
			$files[] = $f;
		}
	}
	closedir($folder);
	
	rsort($files);
	
	foreach ( $files as $file ){
		$file = trim($file);
		
		if ( !preg_match('/^([0-9]+)\-([0-9]+)\-([0-9]+)\-([0-9]+)\.txt$/', $file) ){
			continue;
		}
		
		$file = substr($file, 0, -4);
		list($time, $phone, $icq, $partner_id) = explode('-', $file, 4);
		
		$log[] = array(
			'time'			=> $time,
			'phone'			=> $phone,
			'icq'			=> $icq,
			'partner_id'	=> $partner_id
		);
	}
	
	return $log;
}

/**
 *       
 *
 * @param string $message
 */
function dieMessage($message){
	//     _billing.php
	if ( function_exists('return_result') ){
		 return_result($message);
	}
	
	die($message);
}